--------------------------------------------------------------------------------
--
-- Copyright (C) 2002 The Chameleon Team
--
-- This program is free software; you can redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the Free 
-- Software Foundation; either version 2 of the License, or (at your option) 
-- any later version. This program is distributed in the hope that it will be 
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
-- See the GNU General Public License for more details. 
-- You should have received a copy of the GNU General Public License along
-- with this program; if not, write to the Free Software Foundation, Inc., 
-- 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
--
--------------------------------------------------------------------------------

module Name(Name(..), name, incName, nameStr, nameNum) where

newtype Name = Name (String,Integer)

name = curry Name

instance Eq Name where
    Name (_,n) == Name (_,m) = n == m

instance Ord Name where
    compare (Name (_,n)) (Name (_,m)) = compare n m

instance Show Name where
    show n@(Name (s,a)) = s -- ++ "." ++ show a


incName :: Name -> Name
incName (Name (s,n)) = Name (s,n+1)

nameStr :: Name -> String
nameStr (Name (s,_)) = s

nameNum :: Name -> Integer
nameNum (Name (_,n)) = n
